﻿using System;
using System.Web;
using System.Web.UI;
using System.Web.UI.WebControls;

using System.Data;
using System.Configuration;
using System.Web.Security;
using System.Web.UI.WebControls.WebParts;
using System.Web.UI.HtmlControls;
using Telerik.Web.UI;
using System.Collections.Generic;
using System.Text;

public partial class SearchMultipleValues : System.Web.UI.Page
{
    protected void RadGrid1_ItemDataBound(object sender, GridItemEventArgs e)
    {
        if (e.Item is GridFilteringItem)
        {
            RadComboBox combo = (e.Item as GridFilteringItem).FindControl("RadComboBoxCountry") as RadComboBox;
            if (ViewState["Countries"] != null)
            {
                foreach (string country in (List<string>)ViewState["Countries"])
                {
                    combo.FindItemByText(country).Checked = true;
                }
            }
        }
    }
    bool isFiltered = false;
    protected void RadGrid1_ItemCommand(object sender, GridCommandEventArgs e)
    {
        if (e.CommandName == RadGrid.FilterCommandName)
        {
            isFiltered = true;
        }
    }
    protected void ImageButton1_Click(object sender, ImageClickEventArgs e)
    {
        GridFilteringItem filterItem = (sender as ImageButton).NamingContainer as GridFilteringItem;
        RadComboBox combo = filterItem.FindControl("RadComboBoxCountry") as RadComboBox;

        List<string> expressions = new List<string>();
        List<string> countries = new List<string>();
        foreach (RadComboBoxItem item in combo.CheckedItems)
        {
            countries.Add(item.Text);
            expressions.Add("(it[\"ShipCountry\"].ToString().Contains(\"" + item.Text + "\"))");
        }
        isFiltered = true;
        string value = string.Join("OR", expressions.ToArray());
        ViewState["CountryFilterValue"] = string.IsNullOrEmpty(value) ? value : "(" + value + ")";
        ViewState["Countries"] = countries;
    }
    protected void RadGrid1_PreRender(object sender, EventArgs e)
    {
        if (isFiltered)
        {
            string[] expressions = RadGrid1.MasterTableView.FilterExpression.Split(new string[] { "AND" }, StringSplitOptions.None);
            List<string> columnExpressions = new List<string>(expressions);
            foreach (string expression in columnExpressions)
            {
                if (expression.Contains("[\"ShipCountry\"]"))
                {
                    columnExpressions.Remove(expression);
                    break;
                }
            }
            string finalExpression = string.Join("AND", columnExpressions.ToArray());
            string countryFilterValue = (string)ViewState["CountryFilterValue"];
            if (!string.IsNullOrEmpty(countryFilterValue))
            {
                if (!string.IsNullOrEmpty(finalExpression))
                {
                    finalExpression += " AND ";
                }
                finalExpression += countryFilterValue;
            }
            RadGrid1.MasterTableView.FilterExpression = finalExpression;
            RadGrid1.MasterTableView.Rebind();
        }
    }
}
